Erstellt oder aktualisiert einen Serverschlüssel.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Sql/servers/{serverName}/keys/{keyName}?api-version=2025-01-01
URI-Parameter
| Name |
In |
Erforderlich |
Typ |
Beschreibung |
|
keyName
|
path |
True
|
string
|
Der Name des abzurufenden Serverschlüssels.
|
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
Der Name der Ressourcengruppe. Bei dem Namen wird die Groß-/Kleinschreibung nicht beachtet.
|
|
serverName
|
path |
True
|
string
|
Name des Servers
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
Die ID des Zielabonnements. Der Wert muss eine UUID sein.
|
|
api-version
|
query |
True
|
string
minLength: 1
|
Die API-Version, die für diesen Vorgang verwendet werden soll.
|
Anforderungstext
| Name |
Erforderlich |
Typ |
Beschreibung |
|
properties.serverKeyType
|
True
|
ServerKeyType
|
Der Serverschlüsseltyp wie "ServiceManaged", "AzureKeyVault".
|
|
properties.uri
|
|
string
|
Der URI des Serverschlüssels. Wenn der ServerKeyType AzureKeyVault ist, ist der URI erforderlich. Der AKV-URI muss folgendes Format haben: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' oder kann 'https://YourVaultName.vault.azure.net/keys/YourKeyName' sein
|
Antworten
| Name |
Typ |
Beschreibung |
|
200 OK
|
ServerKey
|
Die Aktualisierungsoperation der Ressource 'ServerKey' war erfolgreich
|
|
201 Created
|
ServerKey
|
Die Erstellungsoperation der Ressource 'ServerKey' war erfolgreich
Header
- Location: string
- Retry-After: integer
|
|
202 Accepted
|
|
Ressourcenvorgang akzeptiert.
Header
- Location: string
- Retry-After: integer
|
|
Other Status Codes
|
ErrorResponse
|
Unerwartete Fehlerantwort.
|
Sicherheit
azure_auth
Azure Active Directory OAuth2 Flow.
Typ:
oauth2
Ablauf:
implicit
Autorisierungs-URL:
https://login.microsoftonline.com/common/oauth2/authorize
Bereiche
| Name |
Beschreibung |
|
user_impersonation
|
Identitätswechsel ihres Benutzerkontos
|
Beispiele
Creates or updates a server key
Beispielanforderung
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
/**
* Sample code: Creates or updates a server key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void createsOrUpdatesAServerKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey_01234567890123456789012345678901",
parameters={
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
async function createsOrUpdatesAServerKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
{
serverKeyType: "AzureKeyVault",
uri: "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
},
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdate.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey_01234567890123456789012345678901";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Creates or updates a server key with versionless key
Beispielanforderung
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
/**
* Sample code: Creates or updates a server key with versionless key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void
createsOrUpdatesAServerKeyWithVersionlessKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey", new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update_with_versionless_key.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey",
parameters={
"properties": {"serverKeyType": "AzureKeyVault", "uri": "https://someVault.vault.azure.net/keys/someKey"}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
async function createsOrUpdatesAServerKeyWithVersionlessKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey",
{ serverKeyType: "AzureKeyVault", uri: "https://someVault.vault.azure.net/keys/someKey" },
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdateWithVersionlessKey.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Definitionen
createdByType
Enumeration
Der Identitätstyp, der die Ressource erstellt hat.
| Wert |
Beschreibung |
|
User
|
|
|
Application
|
|
|
ManagedIdentity
|
|
|
Key
|
|
ErrorAdditionalInfo
Objekt
Der Ressourcenverwaltungsfehler zusätzliche Informationen.
| Name |
Typ |
Beschreibung |
|
info
|
object
|
Die zusätzlichen Informationen.
|
|
type
|
string
|
Der zusätzliche Informationstyp.
|
ErrorDetail
Objekt
Das Fehlerdetails.
| Name |
Typ |
Beschreibung |
|
additionalInfo
|
ErrorAdditionalInfo[]
|
Die zusätzlichen Informationen des Fehlers.
|
|
code
|
string
|
Der Fehlercode.
|
|
details
|
ErrorDetail[]
|
Die Fehlerdetails.
|
|
message
|
string
|
Die Fehlermeldung.
|
|
target
|
string
|
Das Fehlerziel.
|
ErrorResponse
Objekt
Fehlerantwort
| Name |
Typ |
Beschreibung |
|
error
|
ErrorDetail
|
Das Fehlerobjekt.
|
ServerKey
Objekt
Ein Serverschlüssel.
| Name |
Typ |
Beschreibung |
|
id
|
string
(arm-id)
|
Vollqualifizierte Ressourcen-ID für die Ressource. Z. B. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
|
|
kind
|
string
|
Art der Verschlüsselungsschutzkomponente. Dies sind Metadaten, die für das Azure-Portal-Erlebnis verwendet werden.
|
|
location
|
string
|
Ressourcenspeicherort.
|
|
name
|
string
|
Der Name der Ressource
|
|
properties.autoRotationEnabled
|
boolean
|
Kennzeichen für die automatische Drehung der Schlüsseldrehung. Entweder wahr oder falsch.
|
|
properties.creationDate
|
string
(date-time)
|
Das Erstellungsdatum des Serverschlüssels.
|
|
properties.keyVersion
|
string
|
Die Version des Serverschlüssels.
|
|
properties.serverKeyType
|
ServerKeyType
|
Der Serverschlüsseltyp wie "ServiceManaged", "AzureKeyVault".
|
|
properties.subregion
|
string
|
Unterregion des Serverschlüssels.
|
|
properties.thumbprint
|
string
|
Fingerabdruck des Serverschlüssels.
|
|
properties.uri
|
string
|
Der URI des Serverschlüssels. Wenn der ServerKeyType AzureKeyVault ist, ist der URI erforderlich. Der AKV-URI muss folgendes Format haben: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' oder kann 'https://YourVaultName.vault.azure.net/keys/YourKeyName' sein
|
|
systemData
|
systemData
|
Azure Resource Manager-Metadaten, die createdBy und modifiedBy-Informationen enthalten.
|
|
type
|
string
|
Der Typ der Ressource. Zum Beispiel "Microsoft. Compute/virtualMachines" oder "Microsoft. Speicher/Speicherkonten"
|
ServerKeyType
Enumeration
Der Verschlüsselungsschutztyp wie "ServiceManaged", "AzureKeyVault".
| Wert |
Beschreibung |
|
ServiceManaged
|
ServiceManaged
|
|
AzureKeyVault
|
AzureKeyVault
|
systemData
Objekt
Metadaten zur Erstellung und letzten Änderung der Ressource.
| Name |
Typ |
Beschreibung |
|
createdAt
|
string
(date-time)
|
Der Zeitstempel der Ressourcenerstellung (UTC).
|
|
createdBy
|
string
|
Die Identität, die die Ressource erstellt hat.
|
|
createdByType
|
createdByType
|
Der Identitätstyp, der die Ressource erstellt hat.
|
|
lastModifiedAt
|
string
(date-time)
|
Der Zeitstempel der letzten Änderung der Ressource (UTC)
|
|
lastModifiedBy
|
string
|
Die Identität, die die Ressource zuletzt geändert hat.
|
|
lastModifiedByType
|
createdByType
|
Der Identitätstyp, der die Ressource zuletzt geändert hat.
|